-- Follow EmergencySetup.sql first
-- Try to use the emergencydemo database
USE emergencydemo;
GO

-- What state is the database in?
SELECT DATABASEPROPERTYEX ('emergencydemo', 'STATUS');
GO

SELECT state_desc FROM sys.databases WHERE name='emergencydemo';
GO

-- Set it in emergency mode to get access
ALTER DATABASE emergencydemo SET EMERGENCY;
GO

-- And try again...
USE emergencydemo;
GO

-- What does the data look like?
-- It still corrupt.
SELECT * FROM salaries;
GO

-- End demo part 1...


-- Try to set the database online
ALTER DATABASE emergencydemo SET ONLINE;
GO

-- Use emergency mode repair
DBCC CHECKDB (emergencydemo, REPAIR_ALLOW_DATA_LOSS) WITH NO_INFOMSGS;
GO

-- What state is the database in?
SELECT state_desc FROM sys.databases WHERE name='emergencydemo';
GO

-- Have to set it in emergency mode again
ALTER DATABASE emergencydemo SET EMERGENCY;
GO
DBCC CHECKDB (emergencydemo, REPAIR_ALLOW_DATA_LOSS) WITH NO_INFOMSGS;
GO

-- Have to set it in single-user mode as well...
ALTER DATABASE emergencydemo SET SINGLE_USER;
GO
DBCC CHECKDB (emergencydemo, REPAIR_ALLOW_DATA_LOSS) WITH NO_INFOMSGS;
GO

-- Set it back to multi-user and we're ok again, but with corrupt data
ALTER DATABASE emergencydemo SET MULTI_USER;
GO

USE EMERGENCYDEMO;
GO

SELECT * FROM salaries;
GO

-- Now, show that recovery would have worked. Shutdown SQL Server,
-- substitute the old emergencydemo database files and restart.
USE EMERGENCYDEMO;
GO

SELECT * FROM salaries;
GO
