-- Emergency mode Demo
-- Blog post: http://blogs.msdn.com/sqlserverstorageengine/archive/2006/06/18/636105.aspx
-- Rangers April 2007

-- Make sure we start with a clean database
IF DATABASEPROPERTY (N'emergencydemo', 'Version') > 0 DROP DATABASE emergencydemo;
GO

CREATE DATABASE emergencydemo;
GO

USE emergencydemo;
GO

-- Create a table to work with
CREATE TABLE salaries (
	FirstName	CHAR (20),
	LastName	CHAR (20),
	Salary		INT);
GO

INSERT INTO salaries VALUES ('John', 'Williamson', 10000);
INSERT INTO salaries VALUES ('Stephen', 'Brown', 12000);
INSERT INTO salaries VALUES ('Jack', 'Bauer', 10000);
GO

-- Now start a transaction and do an update
BEGIN TRANSACTION;
GO

UPDATE salaries SET Salary = 0 WHERE LastName='Brown';
GO

-- Now simulate a checkpoint
CHECKPOINT;
GO

-- And now we crash...
-- In another window, run EmergencyShutdown.sql
-- In a File Explorer window, make copies of the emergencydemo
-- database files, then delete its log file. Restart the server.
